cookutils view cook @ rev 435

cook: we may have a local bdep not in wok, not on mirror but in local repo
author Christophe Lincoln <pankso@slitaz.org>
date Tue May 22 11:03:36 2012 +0200 (2012-05-22)
parents d9b8c75bb5bb
children cc91909f0591
line source
1 #!/bin/sh
2 #
3 # Cook - A tool to cook and generate SliTaz packages. Read the README
4 # before adding or modifing any code in cook!
5 #
6 # Copyright (C) SliTaz GNU/Linux - GNU gpl v3
7 # Author: Christophe Lincoln <pankso@slitaz.org>
8 #
9 . /usr/lib/slitaz/libcook.sh
11 #
12 # Functions
13 #
15 usage() {
16 cat << EOT
18 $(echo -e "\033[1m$(gettext "Usage:")\033[0m") cook [package|command] [list|--option]
20 $(echo -e "\033[1m$(gettext "Commands:")\033[0m")
21 usage|help $(gettext "Display this short usage.")
22 setup $(gettext "Setup your build environment.")
23 *-setup $(gettext "Setup a cross environment.")
24 test $(gettext "Test environment and cook a package.")
25 list-wok $(gettext "List packages in the wok.")
26 search $(gettext "Simple packages search function.")
27 new $(gettext "Create a new package with a receipt".)
28 list $(gettext "Cook a list of packages.")
29 clean-wok $(gettext "Clean-up all packages files.")
30 clean-src $(gettext "Clean-up all packages sources.")
31 pkgdb $(gettext "Create packages DB lists and flavors.")
33 $(echo -e "\033[1m$(gettext "Options:")\033[0m")
34 --clean|-c Cook : $(gettext "clean the package in the wok.")
35 --install|-i Cook : $(gettext "cook and install the package.")
36 --getsrc|-gs Cook : $(gettext "get the package source tarball.")
37 --block|-b Cook : $(gettext "Block a package so cook will skip it.")
38 --unblock|-ub Cook : $(gettext "Unblock a blocked package.")
39 --interactive|-x New : $(gettext "create a receipt interactively.")
40 --wok Setup: $(gettext "clone the cooking wok from Hg repo.")
41 --stable Setup: $(gettext "clone the stable wok from Hg repo.")
42 --undigest Setup: $(gettext "clone the undigest wok from Hg repo.")
43 --tiny Setup: $(gettext "clone the tiny SliTaz wok from Hg repo.")
44 --forced Setup: $(gettext "force reinstall of chroot packages.")
45 --flavors Pkgdb: $(gettext "create up-to-date flavors files.")
47 EOT
48 exit 0
49 }
51 # Log activities, we want first letter capitalized.
52 log() {
53 grep ^[A-Z] | \
54 sed s"#^[A-Z]\([^']*\)#$(date '+%Y-%m-%d %H:%M') : \0#" >> $activity
55 }
57 # We don't want these escapes in web interface.
58 clean_log() {
59 sed -i -e s'|\[70G\[ \[1;32m| |' \
60 -e s'|\[0;39m \]||' $LOGS/$pkg.log
61 }
63 # Be sure package exists in wok.
64 check_pkg_in_wok() {
65 if [ ! -d "$WOK/$pkg" ]; then
66 gettext -e "\nUnable to find package in the wok:"
67 echo -e " $pkg\n" && exit 1
68 fi
69 }
71 if_empty_value() {
72 if [ -z "$value" ]; then
73 gettext "QA: empty variable:"; echo -e " ${var}=\"\"\n"
74 exit 1
75 fi
76 }
78 # Initialize files used in $CACHE
79 init_db_files() {
80 gettext "Creating directories structure in:"; echo " $SLITAZ"
81 mkdir -p $WOK $PKGS $SRC $CACHE $LOGS
82 gettext "Creating DB files in:"; echo " $CACHE"
83 for f in $activity $command $broken $blocked
84 do
85 touch $f
86 done
87 }
89 # QA: check a receipt consistency before building.
90 receipt_quality() {
91 gettext -e "QA: checking package receipt...\n"
92 unset online
93 if ifconfig | grep -q -A 1 "^[a-z]*[0-9]" | fgrep 'addr:'; then
94 online="online"
95 fi
96 for var in PACKAGE VERSION CATEGORY SHORT_DESC MAINTAINER WEB_SITE
97 do
98 unset value
99 value="$(. $receipt ; eval echo \$$var)"
100 case "$var" in
101 PACKAGE|VERSION|SHORT_DESC)
102 if_empty_value ;;
103 CATEGORY)
104 [ -z "$value" ] && value="empty"
105 valid="base-system x-window utilities network graphics \
106 multimedia office development system-tools security games \
107 misc meta non-free"
108 if ! echo "$valid" | grep -q -w "$value"; then
109 gettext "QA: unknown category:"; echo -e " $value\n"
110 exit 1
111 fi ;;
112 WEB_SITE)
113 # We don't check WGET_URL since if dl is needed it will fail.
114 # Break also if we're not online. Here error is not fatal.
115 if_empty_value
116 [ -z "$online" ] || break
117 if ! busybox wget -T 12 -s $value 2>/dev/null; then
118 gettext "QA: Unable to reach:"; echo -e " $value"
119 fi ;;
120 esac
121 done
122 }
124 # Paths used in receipt and by cook itself.
125 set_paths() {
126 pkgdir=$WOK/$PACKAGE
127 src=$pkgdir/source/$PACKAGE-$VERSION
128 taz=$pkgdir/taz
129 pack=$taz/$PACKAGE-${VERSION}${EXTRAVERSION}
130 fs=$pack/fs
131 stuff=$pkgdir/stuff
132 install=$pkgdir/install
133 if [ "$WANTED" ]; then
134 wanted=${WANTED%% *}
135 src=$WOK/$wanted/source/$wanted-$VERSION
136 install=$WOK/$wanted/install
137 wanted_stuff=$WOK/$wanted/stuff
138 fi
139 # Kernel version is set from linux-api-headers since it is part of toolchain.
140 if [ -f "$INSTALLED/linux-api-headers/receipt" ]; then
141 kvers=$(grep ^VERSION= $INSTALLED/linux-api-headers/receipt | cut -d '"' -f 2)
142 fi
143 # Old way compatibility.
144 _pkg=$install
145 }
147 # Create source tarball when URL is a SCM.
148 create_tarball() {
149 gettext "Creating tarball: "; echo "$tarball"
150 if [ "$LZMA_SRC" ]; then
151 tar -c $pkgsrc | lzma e $SRC/$tarball -si || exit 1
152 else
153 tar cjf $tarball $pkgsrc || exit 1
154 mv $tarball $SRC && rm -rf $pkgsrc
155 fi
156 }
158 # Get package source. For SCM we are in cache so clone here and create a
159 # tarball here.
160 get_source() {
161 pwd=$(pwd)
162 pkgsrc=${SOURCE:-$PACKAGE}-$VERSION
163 tarball=$pkgsrc.tar.bz2
164 [ "$LZMA_SRC" ] && tarball=$pkgsrc.tar.lzma
165 case "$WGET_URL" in
166 http://*|ftp://*)
167 # Busybox Wget is better!
168 busybox wget -T 60 -c -O $SRC/$TARBALL $WGET_URL || \
169 (echo -e "ERROR: wget $WGET_URL" && exit 1) ;;
170 https://*)
171 wget -c --no-check-certificate -O $SRC/$TARBALL $WGET_URL || \
172 (echo -e "ERROR: wget $WGET_URL" && exit 1) ;;
173 hg*|mercurial*)
174 if $(echo "$WGET_URL" | fgrep -q "hg|"); then
175 url=${WGET_URL#hg|}
176 else
177 url=${WGET_URL#mercurial|}
178 fi
179 gettext -e "Getting source from Hg...\n"
180 echo "URL: $url"
181 gettext "Cloning to: "; echo "$pwd/$pkgsrc"
182 if [ "$BRANCH" ]; then
183 echo "Hg branch: $BRANCH"
184 hg clone $url --rev $BRANCH $pkgsrc || \
185 (echo "ERROR: hg clone $url --rev $BRANCH" && exit 1)
186 else
187 hg clone $url $pkgsrc || (echo "ERROR: hg clone $url" && exit 1)
188 fi
189 rm -rf $pkgsrc/.hg
190 create_tarball ;;
191 git*)
192 url=${WGET_URL#git|}
193 gettext -e "Getting source from Git...\n"
194 echo "URL: $url"
195 git clone $url $pkgsrc || (echo "ERROR: git clone $url" && exit 1)
196 if [ "$BRANCH" ]; then
197 echo "Git branch: $BRANCH"
198 cd $pkgsrc && git checkout $BRANCH && cd ..
199 fi
200 create_tarball ;;
201 cvs*)
202 url=${WGET_URL#cvs|}
203 mod=$PACKAGE
204 [ "$CVS_MODULE" ] && mod=$CVS_MODULE
205 gettext -e "Getting source from CVS...\n"
206 echo "URL: $url"
207 [ "$CVS_MODULE" ] && echo "CVS module: $mod"
208 gettext "Cloning to: "; echo "$pwd/$mod"
209 cvs -d:$url co $mod && mv $mod $pkgsrc
210 create_tarball ;;
211 svn*|subversion*)
212 if $(echo "$WGET_URL" | fgrep -q "svn|"); then
213 url=${WGET_URL#svn|}
214 else
215 url=${WGET_URL#subversion|}
216 fi
217 gettext -e "Getting source from SVN...\n"
218 echo "URL: $url"
219 if [ "$BRANCH" ]; then
220 echo t | svn co $url -r $BRANCH $pkgsrc
221 else
222 echo t | svn co $url $pkgsrc
223 fi
224 create_tarball ;;
225 *)
226 gettext -e "\nERROR: Unable to handle:"; echo -e " $WGET_URL \n" | \
227 tee -a $LOGS/$PACKAGE.log
228 exit 1 ;;
229 esac
230 }
232 # Extract source package.
233 extract_source() {
234 if [ ! -s "$SRC/$TARBALL" ]; then
235 local url
236 url="http://mirror.slitaz.org/sources/packages"
237 url=$url/${TARBALL:0:1}/$TARBALL
238 gettext "Getting source from mirror:"; echo " $url"
239 busybox wget -c -P $SRC $url || echo -e "ERROR: wget $url"
240 fi
241 gettext "Extracting:"; echo " $TARBALL"
242 case "$TARBALL" in
243 *.tar.gz|*.tgz) tar xzf $SRC/$TARBALL 2>/dev/null ;;
244 *.tar.bz2|*.tbz|*.tbz2) tar xjf $SRC/$TARBALL 2>/dev/null ;;
245 *.tar.lzma) tar xaf $SRC/$TARBALL ;;
246 *.tar) tar xf $SRC/$TARBALL ;;
247 *.zip|*.xpi) unzip -o $SRC/$TARBALL ;;
248 *.xz) unxz -c $SRC/$TARBALL | tar xf - ;;
249 *.Z) uncompress -c $SRC/$TARBALL | tar xf - ;;
250 *.rpm) rpm2cpio $SRC/$TARBALL | cpio -idm --quiet ;;
251 *.run) /bin/sh $SRC/$TARBALL $RUN_OPTS ;;
252 *) cp $SRC/$TARBALL $(pwd) ;;
253 esac
254 }
256 # Display cooked package summary.
257 summary() {
258 cd $WOK/$pkg
259 [ -d install ] && prod=$(du -sh install | awk '{print $1}' 2>/dev/null)
260 fs=$(du -sh taz/* | awk '{print $1}')
261 size=$(du -sh $PKGS/$pkg-${VERSION}*.tazpkg | awk '{print $1}')
262 files=$(cat taz/$pkg-*/files.list | wc -l)
263 cookdate=$(date "+%Y-%m-%d %H:%M")
264 sec=$time
265 div=$(( ($time + 30) / 60))
266 [ "$div" != 0 ] && min="~ ${div}m"
267 gettext "Summary for:"; echo " $PACKAGE $VERSION"
268 separator
269 [ "$prod" ] && echo "Produced : $prod"
270 cat << EOT
271 Packed : $fs
272 Compressed : $size
273 Files : $files
274 Cook time : ${sec}s $min
275 Cook date : $cookdate
276 Host arch : $ARCH
277 $(separator)
278 EOT
279 }
281 # Display debugging error info.
282 debug_info() {
283 echo -e "\nDebug information"
284 separator
285 echo "Cook date: $(date '+%Y-%m-%d %H:%M')"
286 for error in \
287 ERROR "No package" "cp: can't" "can't open" "can't cd" \
288 "error:" "fatal error:"
289 do
290 fgrep "$error" $LOGS/$pkg.log
291 done
292 separator && newline
293 }
295 # Copy all generic files (locale, pixmaps, .desktop). We use standard paths,
296 # so some packages need to copy these files with the receipt and genpkg_rules.
297 copy_generic_files() {
298 # $LOCALE is set in cook.conf
299 if [ "$LOCALE" ]; then
300 if [ -d "$install/usr/share/locale" ]; then
301 mkdir -p $fs/usr/share/locale
302 for i in $LOCALE
303 do
304 if [ -d "$install/usr/share/locale/$i" ]; then
305 cp -a $install/usr/share/locale/$i $fs/usr/share/locale
306 fi
307 done
308 fi
309 fi
311 # Generic pixmaps copy can be disabled with GENERIC_PIXMAPS="no"
312 if [ "$GENERIC_PIXMAPS" != "no" ]; then
313 if [ -d "$install/usr/share/pixmaps" ]; then
314 mkdir -p $fs/usr/share/pixmaps
315 cp -a $install/usr/share/pixmaps/$PACKAGE.png \
316 $fs/usr/share/pixmaps 2>/dev/null || continue
317 cp -a $install/usr/share/pixmaps/$PACKAGE.xpm \
318 $fs/usr/share/pixmaps 2>/dev/null || continue
319 fi
321 # Custom or homemade PNG pixmap can be in stuff.
322 if [ -f "$stuff/$PACKAGE.png" ]; then
323 mkdir -p $fs/usr/share/pixmaps
324 cp -a $stuff/$PACKAGE.png $fs/usr/share/pixmaps
325 fi
326 fi
328 # Desktop entry (.desktop).
329 # Generic desktop entry copy can be disabled with GENERIC_MENUS="no"
330 if [ "$GENERIC_MENUS" != "no" ]; then
331 if [ -d "$install/usr/share/applications" ] && [ "$WANTED" == "" ]; then
332 cp -a $install/usr/share/applications $fs/usr/share
333 fi
334 fi
336 # Homemade desktop file(s) can be in stuff.
337 if [ -d "$stuff/applications" ]; then
338 mkdir -p $fs/usr/share
339 cp -a $stuff/applications $fs/usr/share
340 fi
341 if [ -f "$stuff/$PACKAGE.desktop" ]; then
342 mkdir -p $fs/usr/share/applications
343 cp -a $stuff/$PACKAGE.desktop $fs/usr/share/applications
344 fi
345 }
347 # Find and strip : --strip-all (-s) or --strip-debug on static libs as well
348 # as removing uneeded files like in Python packages. Cross compiled binaries
349 # must be stripped with cross-tools aka $ARCH-slitaz-*-strip
350 strip_package() {
351 case "$ARCH" in
352 arm|x86_64) export STRIP=${HOST_SYSTEM}-strip ;;
353 *) export STRIP=strip ;;
354 esac
355 gettext "Executing strip on all files..."
356 for dir in $fs/bin $fs/sbin $fs/usr/bin $fs/usr/sbin $fs/usr/games
357 do
358 if [ -d "$dir" ]; then
359 find $dir -type f -exec $STRIP -s '{}' 2>/dev/null \;
360 fi
361 done
362 find $fs -name "*.so*" -exec $STRIP -s '{}' 2>/dev/null \;
363 find $fs -name "*.a" -exec $STRIP --strip-debug '{}' 2>/dev/null \;
364 status
366 # Remove Python .pyc and .pyo from packages.
367 if echo "$PACKAGE $DEPENDS" | fgrep -q "python"; then
368 gettext "Removing Python compiled files..."
369 find $fs -type f -name "*.pyc" -delete 2>/dev/null
370 find $fs -type f -name "*.pyo" -delete 2>/dev/null
371 status
372 fi
374 # Remove Perl perllocal.pod and .packlist from packages.
375 if echo "$DEPENDS" | fgrep -q "perl"; then
376 gettext "Removing Perl compiled files..."
377 find $fs -type f -name "perllocal.pod" -delete 2>/dev/null
378 find $fs -type f -name ".packlist" -delete 2>/dev/null
379 status
380 fi
381 }
383 # Remove installed deps.
384 remove_deps() {
385 # Now remove installed build deps.
386 diff="$CACHE/installed.cook.diff"
387 if [ -s "$CACHE/installed.cook.diff" ]; then
388 deps=$(cat $diff | grep ^+[a-zA-Z0-9] | sed s/^+//)
389 nb=$(cat $diff | grep ^+[a-zA-Z0-9] | wc -l)
390 gettext "Build dependencies to remove:"; echo " $nb $root"
391 gettext "Removing:"
392 for dep in $deps
393 do
394 echo -n " $dep"
395 echo 'y' | tazpkg remove $dep --root=$root >/dev/null
396 done
397 echo -e "\n"
398 # Keep the last diff for debug and info.
399 mv -f $CACHE/installed.cook.diff $CACHE/installed.diff
400 fi
401 }
403 # The main cook function.
404 cookit() {
405 echo "Cook: $PACKAGE $VERSION"
406 separator
407 set_paths
409 # Handle cross-tools.
410 case "$ARCH" in
411 arm|x86_64)
412 # CROSS_COMPILE is used by at least Busybox and the kernel to set
413 # the cross-tools prefix but first check if sysroot is used.
414 if [ "$SYSROOT" ]; then
415 echo "$ARCH sysroot: $SYSROOT"
416 else
417 echo "Adding /usr/cross/$ARCH/bin to PATH"
418 export PATH=$PATH:$CROSS_PREFIX/bin
419 fi
420 export CROSS_COMPILE=${HOST_SYSTEM}-
421 echo "Using cross-tools: $CROSS_COMPILE"
422 export CC=${HOST_SYSTEM}-gcc
423 export CXX=${HOST_SYSTEM}-g++
424 export AR=${HOST_SYSTEM}-ar
425 export AS=${HOST_SYSTEM}-as
426 export RANLIB=${HOST_SYSTEM}-ranlib
427 export LD=${HOST_SYSTEM}-ld
428 export STRIP=${HOST_SYSTEM}-strip
429 # Set root path when cross compiling. ARM tested but not x86_64
430 # When cross compiling we must install build deps in CROSS_PREFIX
431 # or SYSROOT when it will be support by cross (the final goal is
432 # to use only the sysroot method).
433 root=$CROSS_PREFIX
434 arch="-${ARCH}" ;;
435 esac
437 [ "$QA" ] && receipt_quality
438 cd $pkgdir
439 rm -rf install taz source
441 # Disable -pipe if less than 512Mb free RAM.
442 free=$(free | fgrep '/+ buffers' | tr -s ' ' | cut -f 4 -d ' ')
443 if [ "$free" -lt 524288 ] && [ "$CFLAGS" != "${CFLAGS/-pipe}" ]; then
444 gettext -e "Disabling -pipe compile flag: $free RAM\n"
445 CFLAGS="${CFLAGS/-pipe}" && CFLAGS=$(echo "$CFLAGS" | tr -s ' ')
446 CXXFLAGS="${CXXFLAGS/-pipe}" && \
447 CXXFLAGS=$(echo "$CXXFLAGS" | tr -s ' ')
448 fi
449 unset free
451 # Export flags and path to be used by make and receipt.
452 DESTDIR=$pkgdir/install
453 export DESTDIR MAKEFLAGS CFLAGS CXXFLAGS CONFIG_SITE LC_ALL=C LANG=C
454 #LDFLAGS
456 # Check for build deps and handle implicit depends of *-dev packages
457 # (ex: libusb-dev :: libusb).
458 rm -f $CACHE/installed.local $CACHE/installed.web $CACHE/missing.dep
459 touch $CACHE/installed.local $CACHE/installed.web
460 [ "$BUILD_DEPENDS" ] && gettext -e "Checking build dependencies...\n"
461 [ "$root" ] && echo "Using packages DB: ${root}$DB"
462 for dep in $BUILD_DEPENDS
463 do
464 implicit=${dep%-dev}
465 for i in $dep $implicit
466 do
467 if [ ! -f "${root}$INSTALLED/$i/receipt" ]; then
468 # Try local package first. In some cases implicit doesn't exist, ex:
469 # libboost-dev exists but not libboost, so check if we got vers.
470 unset vers
471 vers=$(. $WOK/$i/receipt 2>/dev/null ; echo $VERSION)
472 # We may have a local package.
473 if [ ! "$vers" ]; then
474 vers=$(grep "^$i |" $PKGS/packages.desc | awk '{print $3}')
475 fi
476 debug "bdep: $i version: $vers"
477 if [ -f "$PKGS/$i-${vers}${arch}.tazpkg" ]; then
478 echo $i-${vers}${arch}.tazpkg >> $CACHE/installed.local
479 else
480 # Priority to package version in wok (maybe more up-to-date)
481 # than the mirrored one.
482 if [ "$vers" ]; then
483 if fgrep -q $i-${vers}${arch} ${root}$DB/packages.list; then
484 echo $i >> $CACHE/installed.web
485 else
486 # So package exists in wok but not available.
487 gettext "Missing dep (wok/pkg):"; echo " $i $vers"
488 echo $i >> $CACHE/missing.dep
489 fi
490 else
491 # Package is not in wok but may be in online repo.
492 if fgrep -q $i-${vers}${arch} ${root}$DB/packages.list; then
493 echo $i >> $CACHE/installed.web
494 else
495 echo "ERROR: unknown dep $i" && exit 1
496 fi
497 fi
498 fi
499 fi
500 done
501 done
503 # Get the list of installed packages
504 cd ${root}$INSTALLED && ls -1 > $CACHE/installed.list
506 # Have we a missing build dep to cook ?
507 if [ -s "$CACHE/missing.dep" ] && [ "$AUTO_COOK" ]; then
508 gettext -e "Auto cook config is set : AUTO_COOK\n"
509 cp -f $LOGS/$PACKAGE.log $LOGS/$PACKAGE.log.$$
510 for i in $(uniq $CACHE/missing.dep)
511 do
512 (gettext "Building dep (wok/pkg) :"; echo " $i $vers") | \
513 tee -a $LOGS/$PACKAGE.log.$$
514 cook $i || (echo -e "ERROR: can't cook dep '$i'\n" && \
515 fgrep "remove: " $LOGS/$i.log && \
516 fgrep "Removing: " $LOGS/$i.log && newline) | \
517 tee -a $LOGS/$PACKAGE.log.$$ && break
518 done
519 rm -f $CACHE/missing.dep
520 mv $LOGS/$PACKAGE.log.$$ $LOGS/$PACKAGE.log
521 fi
523 # QA: Exit on missing dep errors. We exit in both cases, if AUTO_COOK
524 # is enabled and cook fails we have ERROR in log, if no auto cook we have
525 # missing dep in cached file.
526 if fgrep -q "ERROR:" $LOGS/$pkg.log || [ -s "$CACHE/missing.dep" ]; then
527 [ -s "$CACHE/missing.dep" ] && nb=$(cat $CACHE/missing.dep | wc -l)
528 echo "ERROR: missing dep $nb" && exit 1
529 fi
531 # Install local packages: package-version${arch}
532 cd $PKGS
533 for i in $(uniq $CACHE/installed.local)
534 do
535 gettext "Installing dep (pkg/local):"; echo " $i"
536 tazpkg install $i --root=$root >/dev/null
537 done
539 # Install web or cached packages (if mirror is set to $PKGS we only
540 # use local packages).
541 for i in $(uniq $CACHE/installed.web)
542 do
543 gettext "Installing dep (web/cache):"; echo " $i"
544 tazpkg get-install $i --root=$root >/dev/null
545 done
547 # If a cook failed deps are removed.
548 cd ${root}$INSTALLED && ls -1 > $CACHE/installed.cook && cd $CACHE
549 [ ! -s "installed.cook.diff" ] && \
550 busybox diff installed.list installed.cook > installed.cook.diff
551 deps=$(cat installed.cook.diff | grep ^+[a-zA-Z0-9] | wc -l)
553 # Get source tarball and make sure we have source dir named:
554 # $PACKAGE-$VERSION to be standard in receipts. Here we use tar.lzma
555 # tarball if it exists.
556 if [ "$WGET_URL" ] && [ ! -f "$SRC/$TARBALL" ]; then
557 if [ -f "$SRC/${SOURCE:-$PACKAGE}-$VERSION.tar.lzma" ]; then
558 TARBALL=${SOURCE:-$PACKAGE}-$VERSION.tar.lzma
559 LZMA_SRC=""
560 else
561 get_source || exit 1
562 fi
563 fi
564 if [ ! "$WANTED" ] && [ "$TARBALL" ] && [ ! -d "$src" ]; then
565 mkdir -p $pkgdir/source/tmp && cd $pkgdir/source/tmp
566 if ! extract_source ; then
567 get_source
568 extract_source || exit 1
569 fi
570 if [ "$LZMA_SRC" ]; then
571 cd $pkgdir/source
572 if [ "$(ls -A tmp | wc -l)" -gl 1 ] || [ -f "$(echo tmp/*)" ]; then
573 mv tmp tmp-1 && mkdir tmp
574 mv tmp-1 tmp/${SOURCE:-$PACKAGE}-$VERSION
575 fi
576 if [ -d "tmp/${SOURCE:-$PACKAGE}-$VERSION" ]; then
577 cd tmp && tar -c * | lzma e $SRC/$TARBALL -si
578 fi
579 fi
580 cd $pkgdir/source/tmp
581 # Some archives are not well done and don't extract to one dir (ex lzma).
582 files=$(ls | wc -l)
583 [ "$files" == 1 ] && [ -d "$(ls)" ] && mv * ../$PACKAGE-$VERSION
584 [ "$files" == 1 ] && [ -f "$(ls)" ] && mkdir -p ../$PACKAGE-$VERSION && \
585 mv * ../$PACKAGE-$VERSION/$TARBALL
586 [ "$files" -gt 1 ] && mkdir -p ../$PACKAGE-$VERSION && \
587 mv * ../$PACKAGE-$VERSION
588 cd .. && rm -rf tmp
589 fi
591 # Execute receipt rules.
592 if grep -q ^compile_rules $receipt; then
593 echo "Executing: compile_rules"
594 echo "CFLAGS : $CFLAGS"
595 #echo "LDFLAGS : $LDFLAGS"
596 [ -d "$src" ] && cd $src
597 compile_rules $@ || exit 1
598 # Stay compatible with _pkg
599 [ -d "$src/_pkg" ] && mv $src/_pkg $install
600 # QA: compile_rules success so valid.
601 mkdir -p $install
602 else
603 # QA: No compile_rules so no error, valid.
604 mkdir -p $install
605 fi
606 separator && newline
608 # Execute testsuite.
609 if grep -q ^testsuite $receipt; then
610 echo "Running testsuite"
611 separator
612 testsuite $@ || exit 1
613 separator && newline
614 fi
615 }
617 # Cook quality assurance.
618 cookit_quality() {
619 if [ ! -d "$WOK/$pkg/install" ] && [ ! "$WANTED" ]; then
620 echo -e "ERROR: cook failed" | tee -a $LOGS/$pkg.log
621 fi
622 # ERROR can be echoed any time in cookit()
623 if fgrep -q ERROR: $LOGS/$pkg.log; then
624 debug_info | tee -a $LOGS/$pkg.log
625 rm -f $command && exit 1
626 fi
627 }
629 # Create the package. Wanted to use Tazpkg to create a tazpkg package at first,
630 # but it doesn't handle EXTRAVERSION.
631 packit() {
632 set_paths
634 # Handle cross compilation
635 case "$ARCH" in
636 arm|x86_64) arch="-$ARCH" ;;
637 esac
639 echo "Pack: $PACKAGE ${VERSION}${arch}"
640 separator
642 if grep -q ^genpkg_rules $receipt; then
643 gettext -e "Executing: genpkg_rules\n"
644 set -e && cd $pkgdir && mkdir -p $fs
645 genpkg_rules || echo -e "\nERROR: genpkg_rules failed\n" >> \
646 $LOGS/$pkg.log
647 else
648 gettext "No packages rules: meta package"; echo
649 mkdir -p $fs
650 fi
652 # First QA check to stop now if genpkg_rules failed.
653 if fgrep -q ERROR: $LOGS/$pkg.log; then
654 exit 1
655 fi
657 cd $taz
658 for file in receipt description.txt
659 do
660 [ ! -f "../$file" ] && continue
661 gettext "Copying"; echo -n " $file..."
662 cp -f ../$file $pack && chown 0.0 $pack/$file && status
663 done
664 copy_generic_files
666 # Create files.list with redirecting find output.
667 gettext "Creating the list of files..." && cd $fs
668 find . -type f -print > ../files.list
669 find . -type l -print >> ../files.list
670 cd .. && sed -i s/'^.'/''/ files.list
671 status
673 # Strip and stuff files.
674 strip_package
676 # Md5sum of files.
677 gettext "Creating md5sum of files..."
678 while read file; do
679 [ -L "fs$file" ] && continue
680 [ -f "fs$file" ] || continue
681 case "$file" in
682 /lib/modules/*/modules.*|*.pyc) continue ;;
683 esac
684 md5sum "fs$file" | sed 's/ fs/ /'
685 done < files.list > md5sum
686 status
687 UNPACKED_SIZE=$(du -chs fs receipt files.list md5sum \
688 description.txt 2> /dev/null | awk \
689 '{ sz=$1 } END { print sz }')
691 # Build cpio archives.
692 gettext "Compressing the fs... "
693 find fs | cpio -o -H newc --quiet | lzma e fs.cpio.lzma -si
694 rm -rf fs
695 status
696 PACKED_SIZE=$(du -chs fs.cpio.lzma receipt files.list \
697 md5sum description.txt 2> /dev/null | awk \
698 '{ sz=$1 } END { print sz }')
699 gettext "Updating receipt sizes..."
700 sed -i s/^PACKED_SIZE.*$// receipt
701 sed -i s/^UNPACKED_SIZE.*$// receipt
702 sed -i "s/^PACKAGE=/PACKED_SIZE=\"$PACKED_SIZE\"\nUNPACKED_SIZE=\"$UNPACKED_SIZE\"\nPACKAGE=/" receipt
703 status
705 # Set extra version.
706 if [ "$EXTRAVERSION" ]; then
707 gettext "Updating receipt EXTRAVERSION: "; echo -n "$EXTRAVERSION"
708 sed -i s/^EXTRAVERSION.*$// receipt
709 sed -i "s/^VERSION=/EXTRAVERSION=\"$EXTRAVERSION\"\nVERSION=/" receipt
710 status
711 fi
713 # Compress.
714 gettext "Creating full cpio archive... "
715 find . -print | cpio -o -H newc --quiet > \
716 ../$PACKAGE-${VERSION}${EXTRAVERSION}${arch}.tazpkg
717 status
718 gettext "Restoring original package tree... "
719 unlzma -c fs.cpio.lzma | cpio -idm --quiet
720 status
721 rm fs.cpio.lzma && cd ..
723 # QA and give info.
724 tazpkg=$(ls *.tazpkg)
725 packit_quality
726 separator && gettext "Package:"; echo -e " $tazpkg\n"
727 }
729 # Verify package quality and consistency.
730 packit_quality() {
731 #gettext "QA: Checking for broken link..."
732 #link=$(find $fs/usr -type l -follow)
733 #[ "$link" ] && echo -e "\nERROR: broken link in filesystem"
734 #status
736 # Exit if any error found in log file.
737 if fgrep -q ERROR: $LOGS/$pkg.log; then
738 rm -f $command && exit 1
739 fi
741 gettext "QA: Checking for empty package..."
742 files=$(cat $WOK/$pkg/taz/$pkg-*/files.list | wc -l)
743 if [ "$files" == 0 ] && [ "$CATEGORY" != "meta" ]; then
744 echo -e "\nERROR: empty package"
745 rm -f $command && exit 1
746 else
747 # Ls sort by name so the first file is the one we want.
748 old=$(ls $PKGS/$pkg-*.tazpkg 2>/dev/null | head -n 1)
749 status
750 if [ -f "$old" ]; then
751 gettext "Removing old: $(basename $old)"
752 rm -f $old && status
753 fi
754 mv -f $pkgdir/taz/$pkg-*.tazpkg $PKGS
755 sed -i /^${pkg}$/d $broken
756 #gettext "Removing source tree..."
757 #rm -f $WOK/$pkg/source && status
758 fi
759 }
761 # Tic tac, tic tac...
762 tac() {
763 sed '1!G;h;$!d' $1
764 }
766 # Install package on --install or update the chroot.
767 install_package() {
768 case "$ARCH" in
769 arm|x86_64)
770 arch="-${ARCH}"
771 root=$CROSS_PREFIX ;;
772 esac
773 # Install package if requested but skip install if target host doesn't
774 # match build system or it will break the build chroot.
775 build=$(echo $BUILD_SYSTEM | cut -d "-" -f 1)
776 if [ "$inst" ] && [ "$build" == "$ARCH" ]; then
777 if [ -f "$PKGS/$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg" ]; then
778 cd $PKGS && tazpkg install \
779 $PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg --forced
780 else
781 gettext -e "Unable to install package, build has failed.\n\n"
782 exit 1
783 fi
784 fi
786 # Install package if part of the chroot to keep env up-to-date.
787 if [ -d "${root}$INSTALLED/$pkg" ]; then
788 . /etc/slitaz/cook.conf
789 . $WOK/$pkg/taz/$pkg-*/receipt
790 echo "Updating $ARCH chroot environment..."
791 echo "Updating chroot: $pkg (${VERSION}${EXTRAVERSION}${arch})" | log
792 cd $PKGS && tazpkg install \
793 $pkg-${VERSION}${EXTRAVERSION}${arch}.tazpkg \
794 --forced --root=$root
795 fi
796 }
798 # Launch the cook command into a chroot jail protected by aufs.
799 # The current filesystems are used read-only and updates are
800 # stored in a separate branch.
801 try_aufs_chroot() {
803 base=/dev/shm/aufsmnt$$
805 # Can we setup the chroot ? Is it already done ?
806 grep -q ^AUFS_NOT_SUPPORTED $receipt && return
807 [ -n "$AUFS_MOUNTS" -a ! -f /aufs-umount.sh ] || return
808 lsmod | grep -q aufs || modprobe aufs 2> /dev/null || return
809 mkdir ${base}root ${base}rw || return
811 echo "Setup aufs chroot..."
813 # Sanity check
814 for i in / /proc /sys /dev/shm /home ; do
815 case " $AUFS_MOUNTS " in
816 *\ $i\ *) ;;
817 *) AUFS_MOUNTS="$AUFS_MOUNTS $i" ;;
818 esac
819 done
820 for mnt in $(echo $AUFS_MOUNTS | sort | uniq); do
821 mount --bind $mnt ${base}root$mnt
822 if [ $mnt == / ] && ! mount -t aufs -o br=${base}rw:/ none ${base}root; then
823 echo "Aufs mountage failure"
824 umount ${base}root
825 rmdir ${base}*
826 return
827 fi
828 echo "umount ${base}root$mnt" >> ${base}rw/aufs-umount.sh
829 done
831 chroot ${base}root $(cd $(dirname $0); pwd)/$(basename $0) "$@"
832 status=$?
834 echo "Leaving aufs chroot..."
835 tac ${base}rw/aufs-umount.sh | sh
836 rm -rf ${base}rw
837 umount ${base}root
838 rmdir $base*
839 # Dont install pkg twice... it's done after
840 #install_package
841 exit $status
842 }
844 # Create a XML feed for freshly built packages.
845 gen_rss() {
846 pubdate=$(date "+%a, %d %b %Y %X")
847 cat > $FEEDS/$pkg.xml << EOT
848 <item>
849 <title>$PACKAGE $VERSION${EXTRAVERSION}</title>
850 <link>${COOKER_URL}?pkg=$PACKAGE</link>
851 <guid>$PACKAGE-$VERSION${EXTRAVERSION}</guid>
852 <pubDate>$pubdate</pubDate>
853 <description>$SHORT_DESC</description>
854 </item>
855 EOT
856 }
858 #
859 # Commands
860 #
862 case "$1" in
863 usage|help|-u|-h)
864 usage ;;
865 list-wok)
866 gettext -e "\nList of packages in:"; echo " $WOK"
867 separator
868 cd $WOK && ls -1
869 separator
870 echo -n "Packages: " && ls | wc -l
871 newline ;;
872 activity)
873 cat $activity ;;
874 search)
875 # Just a simple search function, we dont need more actually.
876 query="$2"
877 newline
878 gettext "Search results for:"; echo " $query"
879 separator
880 cd $WOK && ls -1 | grep "$query"
881 separator && newline ;;
882 setup)
883 # Setup a build environment
884 check_root
885 echo "Cook: setup environment" | log
886 newline
887 gettext "Setting up your environment"; newline
888 separator && cd $SLITAZ
889 init_db_files
890 gettext "Checking for packages to install..."; echo
891 # Use setup pkgs from cross.conf or cook.conf. When cross compiling
892 # ARCH-setup or 'cross check-env' should be used before: cook setup
893 case "$ARCH" in
894 arm|x86_64)
895 if [ ! -x "/usr/bin/cross" ]; then
896 gettext "ERROR: cross is not installed"; echo
897 exit 1
898 fi
899 gettext "Using config file: /etc/slitaz/cross.conf"; echo
900 . /etc/slitaz/cross.conf ;;
901 esac
902 for pkg in $SETUP_PKGS; do
903 if [ "$forced" ]; then
904 tazpkg -gi $pkg --forced
905 else
906 [ -d "$INSTALLED/$pkg" ] || tazpkg get-install $pkg
907 fi
908 done
910 # Handle --options
911 case "$2" in
912 --wok)
913 hg clone $WOK_URL wok || exit 1 ;;
914 --stable)
915 hg clone $WOK_URL-stable wok || exit 1 ;;
916 --undigest)
917 hg clone $WOK_URL-undigest wok || exit 1 ;;
918 --tiny)
919 hg clone $WOK_URL-tiny wok || exit 1 ;;
920 esac
922 # SliTaz group and permissions
923 if ! grep -q ^slitaz /etc/group; then
924 gettext -e "Adding group: slitaz\n"
925 addgroup slitaz
926 fi
927 gettext -e "Setting permissions for slitaz group...\n"
928 find $SLITAZ -maxdepth 2 -exec chown root.slitaz {} \;
929 find $SLITAZ -maxdepth 2 -exec chmod g+w {} \;
930 separator
931 gettext -e "All done, ready to cook packages :-)\n\n" ;;
932 *-setup)
933 # Setup for cross compiling.
934 arch=${1%-setup}
935 check_root
936 echo "Cook: setup $arch cross environment" | log
937 newline
938 boldify $(gettext "Setting up your cross environment")
939 separator
940 init_db_files
941 sed -i \
942 -e s"/ARCH=.*/ARCH=\"$arch\"/" \
943 -e s'/BUILD_SYSTEM=.*/BUILD_SYSTEM=i486-slitaz-linux/' \
944 /etc/slitaz/cook.conf
945 case "$arch" in
946 arm)
947 sed -i \
948 -e s'/CFLAGS=.*/CFLAGS="-march=armv6"/' \
949 -e s'/HOST_SYSTEM=.*/HOST_SYSTEM=$ARCH-slitaz-linux-gnueabi/' \
950 -e s'/xorg-dev/""/' \
951 /etc/slitaz/cook.conf ;;
952 x86_64)
953 sed -i \
954 -e s'/CFLAGS=.*/CFLAGS=""/' \
955 -e s'/HOST_SYSTEM=.*/HOST_SYSTEM=$ARCH-slitaz-linux/' \
956 /etc/slitaz/cook.conf ;;
957 esac
958 . /etc/slitaz/cook.conf
959 echo "Target arch : $ARCH"
960 echo "Configure args : $CONFIGURE_ARGS"
961 if [ "$SYSROOT" ]; then
962 echo "Arch sysroot : $SYSROOT"
963 CC=/usr/bin/${HOST_SYSTEM}-gcc
964 root=$SYSROOT
965 else
966 echo "Additional path : $CROSS_PREFIX/bin"
967 CC=$CROSS_PREFIX/bin/${HOST_SYSTEM}-gcc
968 root=$CROSS_PREFIX
969 fi
970 # Tell the packages manager wher to find packages.
971 echo "Packages DB : ${root}$DB"
972 mkdir -p ${root}$INSTALLED
973 cd ${root}$DB && rm -f *.bak
974 for list in packages.list packages.desc packages.equiv packages.md5
975 do
976 rm -f $list && ln -s $SLITAZ/packages/$list $list
977 done
978 # We must have the cross compiled glibc-base installed or default
979 # i486 package will be used as dep by tazpkg and then break the
980 # cross environment
981 if [ ! -f "${root}$INSTALLED/glibc-base/receipt" ]; then
982 . /etc/slitaz/cross.conf
983 if [ ! -f "$PKGS/glibc-base-$GLIBC_VERSION-$ARCH.tazpkg" ]; then
984 echo "WARNING: cook glibc-base for $ARCH then run again:"
985 echo "$(basename $0) $ARCH-setup"
986 else
987 echo "Installing : glibc-base-$GLIBC_VERSION-$ARCH.tazpkg"
988 tazpkg install \
989 $PKGS/glibc-base-$GLIBC_VERSION-$ARCH.tazpkg \
990 --root=$root >/dev/null
991 fi
992 fi
993 # Show GCC version or warn if not yet compiled.
994 if [ -x $CC ]; then
995 echo "Cross compiler : ${HOST_SYSTEM}-gcc"
996 else
997 colorize "C compiler is missing: ${HOST_SYSTEM}-gcc" 36
998 echo "Run 'cross compile' to cook a toolchain"
999 fi
1000 separator && newline ;;
1001 test)
1002 # Test a cook environment.
1003 echo "Cook test: testing the cook environment" | log
1004 [ ! -d "$WOK" ] && exit 1
1005 [ ! -d "$WOK/cooktest" ] && cp -r $DATA/cooktest $WOK
1006 cook cooktest ;;
1007 new)
1008 # Create the package folder and an empty receipt.
1009 pkg="$2"
1010 [ "$pkg" ] || usage
1011 newline
1012 if [ -d "$WOK/$pkg" ]; then
1013 echo -n "$pkg " && gettext "package already exists."
1014 echo -e "\n" && exit 1
1015 fi
1016 gettext "Creating"; echo -n " $WOK/$pkg"
1017 mkdir $WOK/$pkg && cd $WOK/$pkg && status
1018 gettext "Preparing the package receipt..."
1019 cp $DATA/receipt .
1020 sed -i s"/^PACKAGE=.*/PACKAGE=\"$pkg\"/" receipt
1021 status && newline
1023 # Interactive mode, asking and seding.
1024 case "$3" in
1025 --interactive|-x)
1026 gettext -e "Entering interactive mode...\n"
1027 separator
1028 echo "Package : $pkg"
1029 # Version.
1030 echo -n "Version : " ; read anser
1031 sed -i s/'VERSION=\"\"'/"VERSION=\"$anser\""/ receipt
1032 # Category.
1033 echo -n "Category : " ; read anser
1034 sed -i s/'CATEGORY=\"\"'/"CATEGORY=\"$anser\""/ receipt
1035 # Short description.
1036 echo -n "Short desc : " ; read anser
1037 sed -i s/'SHORT_DESC=\"\"'/"SHORT_DESC=\"$anser\""/ receipt
1038 # Maintainer.
1039 echo -n "Maintainer : " ; read anser
1040 sed -i s/'MAINTAINER=\"\"'/"MAINTAINER=\"$anser\""/ receipt
1041 # Web site.
1042 echo -n "Web site : " ; read anser
1043 sed -i s#'WEB_SITE=\"\"'#"WEB_SITE=\"$anser\""# receipt
1044 newline
1045 # Wget URL.
1046 echo "Wget URL to download source tarball."
1047 echo "Example : \$GNU_MIRROR/\$PACKAGE/\$TARBALL"
1048 echo -n "Wget url : " ; read anser
1049 sed -i s#'WGET_URL=\"$TARBALL\"'#"WGET_URL=\"$anser\""# receipt
1050 # Ask for a stuff dir.
1051 echo -n "Do you need a stuff directory ? (y/N) : " ; read anser
1052 if [ "$anser" = "y" ]; then
1053 echo -n "Creating the stuff directory..."
1054 mkdir $WOK/$pkg/stuff && status
1055 fi
1056 # Ask for a description file.
1057 echo -n "Are you going to write a description ? (y/N) : " ; read anser
1058 if [ "$anser" = "y" ]; then
1059 echo -n "Creating the description.txt file..."
1060 newline > $WOK/$pkg/description.txt && status
1061 fi
1062 separator
1063 gettext -e "Receipt is ready to use.\n"
1064 newline ;;
1065 esac ;;
1066 list)
1067 # Cook a list of packages (better use the Cooker since it will order
1068 # packages before executing cook).
1069 check_root
1070 [ -z "$2" ] && gettext -e "\nNo list in argument.\n\n" && exit 1
1071 [ ! -f "$2" ] && gettext -e "\nNo list found:" && \
1072 echo -e " $2\n" && exit 1
1073 echo "Cook list starting: $2" | log
1074 for pkg in $(cat $2)
1075 do
1076 cook $pkg || broken
1077 done ;;
1078 clean-wok)
1079 check_root
1080 gettext -e "\nCleaning all packages files..."
1081 rm -rf $WOK/*/taz $WOK/*/install $WOK/*/source
1082 status && newline ;;
1083 clean-src)
1084 check_root
1085 gettext -e "\nCleaning all packages sources..."
1086 rm -rf $WOK/*/source
1087 status && newline ;;
1088 pkgdb)
1089 # Create suitable packages list for TazPKG and only for built packages
1090 # as well as flavors files for TazLiTo. We dont need logs since we do it
1091 # manually to ensure everything is fine before syncing the mirror.
1092 case "$2" in
1093 --flavors)
1094 continue ;;
1095 *)
1096 [ "$2" ] && PKGS="$2"
1097 [ ! -d "$PKGS" ] && \
1098 gettext -e "\nPackages directory doesn't exist\n\n" && exit 1 ;;
1099 esac
1100 time=$(date +%s)
1101 flavors=$SLITAZ/flavors
1102 live=$SLITAZ/live
1103 echo "cook:pkgdb" > $command
1104 echo "Cook pkgdb: Creating all packages lists" | log
1105 newline
1106 gettext "Creating lists for: "; echo "$PKGS"
1107 separator
1108 gettext "Cook pkgdb started: "; date "+%Y-%m-%d %H:%M"
1109 cd $PKGS
1110 rm -f packages.*
1111 gettext -e "Creating: packages.list\n"
1112 ls -1 *.tazpkg | sed s'/.tazpkg//' > $PKGS/packages.list
1113 gettext -e "Creating: packages.md5\n"
1114 md5sum *.tazpkg > $PKGS/packages.md5
1115 md5sum packages.md5 | cut -f1 -d' ' > ID
1116 gettext -e "Creating lists from: "; echo "$WOK"
1117 cd $WOK
1118 for pkg in *
1119 do
1120 unset_receipt
1121 . $pkg/receipt
1122 if [ -f "$PKGS/$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg" ]; then
1123 # PACKED_SIZE and UNPACKED_SIZE are only in built receipt
1124 if [ -s $pkg/taz/*/receipt ]; then
1125 . $pkg/taz/*/receipt
1126 fi
1127 # packages.desc lets us search easily in DB
1128 cat >> $PKGS/packages.desc << EOT
1129 $PACKAGE | ${VERSION}$EXTRAVERSION | $SHORT_DESC | $CATEGORY | $WEB_SITE
1130 EOT
1131 # packages.txt used by tazpkg and tazpkg-web also to provide
1132 # a human readable package list with version and description.
1133 cat >> $PKGS/packages.txt << EOT
1134 $PACKAGE
1135 ${VERSION}$EXTRAVERSION
1136 $SHORT_DESC
1137 $PACKED_SIZE ($UNPACKED_SIZE installed)
1139 EOT
1140 # packages.equiv is used by tazpkg install to check depends.
1141 for i in $PROVIDE; do
1142 DEST=""
1143 echo $i | fgrep -q : && DEST="${i#*:}:"
1144 if grep -qs ^${i%:*}= $PKGS/packages.equiv; then
1145 sed -i "s/^${i%:*}=/${i%:*}=$DEST$PACKAGE /" \
1146 $PKGS/packages.equiv
1147 else
1148 echo "${i%:*}=$DEST$PACKAGE" >> $PKGS/packages.equiv
1149 fi
1150 done
1151 # files.list provides a list of all packages files.
1152 cat $pkg/taz/*/files.list | sed s/^/"$pkg: \0"/ >> \
1153 $PKGS/files.list
1154 fi
1155 done
1157 # Display list size.
1158 gettext -e "Done: packages.desc\n"
1159 gettext -e "Done: packages.txt\n"
1160 gettext -e "Done: packages.equiv\n"
1162 # files.list.lzma
1163 gettext -e "Creating: files.list.lzma\n"
1164 cd $PKGS && lzma e files.list files.list.lzma
1165 rm -f files.list
1167 # Display some info.
1168 separator
1169 nb=$(ls $PKGS/*.tazpkg | wc -l)
1170 time=$(($(date +%s) - $time))
1171 echo -e "Packages: $nb - Time: ${time}s\n"
1173 # Create all flavors files at once. Do we really need code to monitor
1174 # flavors changes ? Lets just build them with packages lists before
1175 # syncing the mirror.
1176 [ "$2" == "--flavors" ] || exit 1
1177 [ ! -d "$flavors" ] && echo -e "Missing flavors: $flavors\n" && exit 1
1178 [ -d "$live" ] || mkdir -p $live
1179 gettext "Creating flavors files in:"; echo " $live"
1180 echo "Cook pkgdb: Creating all flavors" | log
1181 separator
1182 gettext -e "Recharging lists to use latest packages...\n"
1183 tazpkg recharge >/dev/null 2>/dev/null
1185 # We need a custom tazlito config to set working dir to /home/slitaz.
1186 if [ ! -f "$live/tazlito.conf" ]; then
1187 echo "Creating configuration file: tazlito.conf"
1188 cp /etc/tazlito/tazlito.conf $live
1189 sed -i s@WORK_DIR=.*@WORK_DIR=\"/home/slitaz\"@ \
1190 $live/tazlito.conf
1191 fi
1193 # Update Hg flavors repo and pack.
1194 [ -d "$flavors/.hg" ] && cd $flavors && hg pull -u
1196 cd $live
1197 echo "Starting to generate flavors..."
1198 rm -f flavors.list *.flavor
1199 for i in $flavors/*
1200 do
1201 fl=$(basename $i)
1202 echo "Packing flavor: $(basename $i)"
1203 tazlito pack-flavor $fl >/dev/null || exit 1
1204 tazlito show-flavor $fl --brief --noheader 2> \
1205 /dev/null >> flavors.list
1206 done
1207 cp -f $live/*.flavor $live/flavors.list $PKGS
1208 separator && gettext "Flavors size: "; du -sh $live | awk '{print $1}'
1209 newline && rm -f $command ;;
1210 *)
1211 # Just cook and generate a package.
1212 check_root
1213 time=$(date +%s)
1214 pkg="$1"
1215 [ -z "$pkg" ] && usage
1216 receipt="$WOK/$pkg/receipt"
1217 check_pkg_in_wok && newline
1219 unset inst
1220 unset_receipt
1221 . $receipt
1223 # Handle cross compilation.
1225 # CROSS_NOTE: Actually we are running an ARM cooker but running
1226 # the cooker and build each commit in wok is not possible since
1227 # we dont cook the full wok for this arch. For ARM we need a set
1228 # of packages to handle a touch screen desktop, servers but not
1229 # erland.
1231 # The temporary solution is to build only reviewed and tested
1232 # packages with HOST_ARCH set in receipt.
1233 case "$ARCH" in
1234 arm)
1235 if [ ! "$HOST_ARCH" ]; then
1236 echo "cook: HOST_ARCH is not set in $pkg receipt"
1237 echo "cook: This package is not included in: $ARCH"
1238 [ "$CROSS_BUGS" ] && echo "bugs: $CROSS_BUGS"
1239 echo "Cook skip: $pkg is not included in: $ARCH" | log
1240 newline && exit 1
1241 fi ;;
1242 esac
1244 # Some packages are not included in some arch or fail to cross compile.
1245 : ${HOST_ARCH=i486}
1246 if ! $(echo "$HOST_ARCH" | fgrep -q $ARCH); then
1247 echo "cook: HOST_ARCH=$HOST_ARCH"
1248 echo "cook: $pkg doesn't cook or is not included in: $ARCH"
1249 [ "$CROSS_BUGS" ] && echo "bugs: $CROSS_BUGS"
1250 echo "Cook skip: $pkg doesn't cook or is not included in: $ARCH" | log
1251 newline && exit 1
1252 fi
1254 # Skip blocked, 3 lines also for the Cooker.
1255 if grep -q "^$pkg$" $blocked && [ "$2" != "--unblock" ]; then
1256 gettext -e "Blocked package:"; echo -e " $pkg\n" && exit 0
1257 fi
1259 try_aufs_chroot "$@"
1261 # Log and source receipt.
1262 echo "Cook started for: <a href='cooker.cgi?pkg=$pkg'>$pkg</a>" | log
1263 echo "cook:$pkg" > $command
1265 # Display and log info if cook process stopped.
1266 trap 'gettext -e "\n\nCook stopped: control-C\n\n" | \
1267 tee -a $LOGS/$pkg.log' INT
1269 # Handle --options
1270 case "$2" in
1271 --clean|-c)
1272 gettext -e "Cleaning:"; echo -n " $pkg"
1273 cd $WOK/$pkg && rm -rf install taz source
1274 status && newline && exit 0 ;;
1275 --install|-i)
1276 inst='yes' ;;
1277 --getsrc|-gs)
1278 gettext "Getting source for:"; echo " $pkg"
1279 separator && get_source
1280 echo -e "Tarball: $SRC/$TARBALL\n" && exit 0 ;;
1281 --block|-b)
1282 gettext "Blocking:"; echo -n " $pkg"
1283 [ $(grep "^$pkg$" $blocked) ] || echo "$pkg" >> $blocked
1284 status && newline && exit 0 ;;
1285 --unblock|-ub)
1286 gettext "Unblocking:"; echo -n " $pkg"
1287 sed -i "/^${pkg}$/"d $blocked
1288 status && newline && exit 0 ;;
1290 esac
1292 # Check if wanted is built now so we have separate log files.
1293 for wanted in $WANTED ; do
1294 if grep -q "^$wanted$" $blocked; then
1295 echo "WANTED package is blocked: $wanted" | tee $LOGS/$pkg.log
1296 newline && rm -f $command && exit 1
1297 fi
1298 if grep -q "^$wanted$" $broken; then
1299 echo "WANTED package is broken: $wanted" | tee $LOGS/$pkg.log
1300 newline && rm -f $command && exit 1
1301 fi
1302 if [ ! -d "$WOK/$wanted/install" ]; then
1303 cook "$wanted" || exit 1
1304 fi
1305 done
1307 # Cook and pack or exit on error and log everything.
1308 cookit $@ 2>&1 | tee $LOGS/$pkg.log
1309 remove_deps | tee -a $LOGS/$pkg.log
1310 cookit_quality
1311 packit 2>&1 | tee -a $LOGS/$pkg.log
1312 clean_log
1314 # Exit if any error in packing.
1315 if grep -q ^ERROR $LOGS/$pkg.log; then
1316 debug_info | tee -a $LOGS/$pkg.log
1317 rm -f $command && exit 1
1318 fi
1320 # Create an XML feed
1321 gen_rss
1323 # Time and summary
1324 time=$(($(date +%s) - $time))
1325 summary | tee -a $LOGS/$pkg.log
1326 newline
1328 # We may want to install/update.
1329 install_package
1331 # Finally we DONT WANT to build the *-dev or packages with WANTED="$pkg"
1332 # You want automation: use the Cooker Build Bot.
1333 rm -f $command ;;
1334 esac
1336 exit 0